<h2>Što zapravo radi zaštitno kodiranje</h2>

<p>Savladavanjem prethodnih definicija konačno smo spremni za otkrivanje temelja na kojem počiva zaštitno kodiranje. Trebamo još samo jednu novu definiciju.</p>

<p><em>Minimalna distanca koda</em> (ili kraće, <em>distanca koda</em>; podrazumijevamo da se radi o Hammingovoj distanci) je distanca između dvije najbliže riječi promatranog koda. Pogledajmo to ponovno na primjeru koda koji dvobitni podatak štiti na način da ga još jednom ponovi u zaštićenoj kodnoj riječi. Riječi tog koda su bile: {0000, 0101, 1010, 1111}. Kolika je minimalna distanca tog koda? Trebamo izračunati distancu između prve riječ i preostale 3, druge i preostale 3, treće i preostale 3 te četvrte i preostale 3.</p>

<style>
TABLE.priv-t-style {border-style: none; margin-left: auto; margin-right: auto; border-spacing: 0; border-collapse: collapse;}
TABLE.priv-t-style td { text-align: center; padding: 5px;}
TABLE.priv-t-style td.ptlt {border-left: 1px solid black;border-top: 1px solid black;}
TABLE.priv-t-style td.ptlm {border-left: 1px solid black;}
TABLE.priv-t-style td.ptlb {border-left: 1px solid black;border-bottom: 1px solid black;}
TABLE.priv-t-style td.pttm {border-top: 1px solid black;}
TABLE.priv-t-style td.ptrt {border-right: 1px solid black;border-top: 1px solid black;}
TABLE.priv-t-style td.ptbm {border-bottom: 1px solid black;}
TABLE.priv-t-style td.ptrb {border-right: 1px solid black;border-bottom: 1px solid black;}
TABLE.priv-t-style td.ptrm {border-right: 1px solid black;}
</style>
<table class="priv-t-style">
<tr><td>&nbsp;</td><td>0000</td><td>0101</td><td>1010</td><td>1111</td></tr>
<tr><td>0000</td><td class="ptlt">&#8902;</td><td class="pttm">2</td><td class="pttm">2</td><td class="ptrt">4</td></tr>
<tr><td>0101</td><td class="ptlm">2</td><td>&#8902;</td><td>4</td><td class="ptrm">2</td></tr>
<tr><td>1010</td><td class="ptlm">2</td><td>4</td><td>&#8902;</td><td class="ptrm">2</td></tr>
<tr><td>1111</td><td class="ptlb">4</td><td class="ptbm">2</td><td class="ptbm">2</td><td class="ptrb">&#8902;</td></tr>
</table>

<p>Broj izračuna možemo smanjiti ako uočimo da distanca zadovoljava svojstvo simetričnosti: \(d_H(x,y) = d_H(y,x)\): pogledajte prethodnu tablicu i uočite da je simetrična oko glavne dijagonale. Stoga je dovoljno izračunati distance <i>i</i>-te riječi samo onih koje su nakon nje. Distanca između riječi i same sebe je uvijek nula, no taj nas slučaj ne zanima: u tablici smo te situacije označili zvjezdicom.</p>

<p>Različiti kodovi ove će distance imati različite. Neki će kodovi između svih parova kodnih riječi imati jednaku distancu; neki će kodovi imati situaciju koja je nastupila i u našem slučaju - distance će varirati od para do para.</p>

<p>Minimalna distanca koda je minimum od svih izračunatih distanci između (različitih) kodnih riječi. U našem slučaju, to je minimum između 2 i 4 što je 2. Zašto nam je minimalna distanca koda važan pojam?</p>

<div class="mlImportant">
<p>Ako je minimalna distanca koda jednaka <i>d</i>, tada znamo da u kodu ne postoji niti jedan par kodnih riječi koji je na manjoj udaljenosti od <i>d</i>: sve kodne riječi su barem na tolikoj udaljenosti (pogledajte gornju tablicu: sve kodne riječi su barem na udaljenosti 2, a neke su i na većoj). Ako u sustavu djeluju pogreške koje mijenjaju bitove poslane kodne riječi, sada pouzdano znamo da pogreške moraju promijeniti minimalno <i>d</i> bitova (čime će poslanu kodnu riječ pretvoriti onu drugu kodnu riječ koja je na toj distanci) da bi se dogodio slučaj da prijemnik ne može otkriti da su djelovale smetnje koje su mijenjale bitove.</p>
</div>

<p>Primjerice, ako u našem slučaju predajnik pošalje 0000 i dogode se dvije pogreške - na prvom i trećem bitu, prijemnik će primiti 1010 i zaključiti da nema pogrešaka, da mu je poslan podatak 10 i da je shodno tome stigla zaštićena kodna riječ 1010. Mi kao vanjski promatrač vidimo da to nije točno no prijemnik to ne može zaključiti.</p>

<p>Važna posljedica ovoga je sljedeća. <span class="mlUnderline">Zaštitni kod čija je minimalna distanca <i>d</i> može otkriti pojavu najviše <i>d</i>-1 pogreške</span>, što se lijepo može ilustrirati grafički.</p>

<figure class="mlFigure">
<img src="@#file#(greske-hr.svg)" alt="Djelovanje pogrešaka i distanca koda." border="0">
<figcaption>Razmatramo dvije kodne riječi <i>x</i> i <i>y</i> koje su na distanci <i>d</i>=6. Dogodi li se od jedne do 5 pogrešaka, i dalje nećemo doći do druge kodne riječi već ćemo ostati u skupu nelegalnih kodnih riječi koji postoji zahvaljujući redundantnim bitovima.</figcaption>
</figure>

<p>Slika prikazuje dvije kodne riječi (<i>x</i> i <i>y</i>; mali zeleni kružići lijevo i desno) koje se nalaze na distanci 6. Pretpostavimo da je to ujedno i minimalna distanca koda kojemu pripadaju te dvije kodne riječi. Pošaljemo li kodnu riječ <i>x</i>, pogreške će tu kodnu riječ pretvarati u kodnu riječ koja je sve sličnija kodnoj riječi <i>y</i>, i na slici se krećemo od zelenog kružića lijevo po crvenim kružićima udesno. Ti kružići predstavljaju nelegalne riječi koje su na sve većoj i većoj distanci od kodne riječi <i>x</i>. Međutim, ako se dogodi čak 6 pogrešaka, kolika je distanca između <i>x</i> i <i>y</i>, poslana kodna riječ bit će primljena kao <i>y</i> i prijemnik neće moći utvrditi da je došlo do pogreške. Dogodi li se manje od 6 pogrešaka, što je minimalna distanca koda iz ovog primjera, prijemnik će pouzdano moći utvrditi da je došlo do pogreške.</p>

<p>Pitanje koje se odmah nameće je sljedeće: ako prijemnik zna da nešto ne valja (primio je "crvenu" riječ), odnosno da je broj pogrešaka koje su se dogodile manji od 6, može li znati što je točno bilo poslano? Odgovor je: ne može. Ovo ćemo ilustrirati na jednostavnom primjeru prikazanom na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(greske2-hr.svg)" alt="Nemogućnost određivanja izvorne kodne riječi." border="0">
<figcaption>Primili smo kodnu riječ koja odgovara drugom s lijeva crvenom kružiću. Što je bilo poslano?</figcaption>
</figure>

<p>Pogledajte pažljivo sliku. Pretpostavimo da smo primili kodnu riječ koja odgovara drugom s lijeva crvenom kružiću. Možemo li zaključiti što je bilo izvorno poslano? Ako je jedino što znamo činjenica da se dogodilo pet pogrešaka ili manje, tada ne možemo zaključiti što je bilo poslano. Naime, ako je bio poslan <i>x</i>, uz dvije pogreške pri prijenosu primili bismo upravo razmatranu riječ. Ako je pak bio poslan <i>y</i>, uz četiri pogreške pri prijenosu također bismo primili razmatranu riječ. Kako ne znamo koji je slučaj od ta dva nastupio, ne možemo znati niti što je izvorno bilo poslano.
</p>




